(
	plugin textureMap enhVRMST
	name:"EnhancedVRayMultiSubTex"
	classID:#(0x71947a9d, 0x6396bed)
	extends:vraymultisubtex replaceUI:false version:1
	(
		local fileFormats = #( "*.bmp", "*.exr", "*.hdr", "*.ifl", "*.jpe", "*.jpg", "*.jpeg", "*.pic", "*.png", "*.psd", "*.rgb", "*.rgba", "*.sgi", ".tif", "*.tga", "*.tiff", "*.tx")
		local fileTypes = "All Image Formats |*.png;*.bmp;*.tga;*.hdr;*.sgi;*.rgb;*.rgba;*.jpg;*.jpeg;*.jpe;*.exr;*.pic;*.tif;*.tiff;*.tx;*.tex;*.psd;*.ifl|Portable Network Graphics (*.png)|*.png|Windows Bitmap (*.bmp)|*.bmp|Targa Image File (*.tga)|*.tga|Radiance HDR Image (*.hdr)|*.hdr|Silicon Graphics (*.sgi;*.rgb;*.rgba)|*.sgi;*.rgb;*.rgba|JPEG Image File(*.jpg;*.jpeg;*.jpe)|*.jpg;*.jpeg;*.jpe|OpenEXR Image File (*.exr)|*.exr|Softimage PICT File (*.pic)|*.pic|Tagged Image File Format - TIFF (*.tif;*.tiff;*.tx)|*.tif;*.tiff;*.tx|Photoshop (*.tex,*.psd)|*.tex;*.psd|Image File List (*.ifl)|*.ifl|All Files (*.*)|*.*"
		
		local mapsRoot = undefined
		local theMaps = #()
		
		parameters main rollout:params
		(
		)
		rollout params "Mass Loader" width:320 height:144
		(
			button 'btn1' "Click to search for textures" pos:[8,8] width:300 height:32 align:#left
			button 'btn2' "Click to pick textures" pos:[8,48] width:300 height:32 align:#left
			
			on btn1 pressed do
			(
				--open the folder picker
				mapsRoot =  getSavePath caption:"Pick a folder to scan for textures"
				--now for the main process
				if mapsRoot != undefined do 
				(
					--first, clean up the m/s texture
					delegate.deleteSubtex 1 delegate.texMap_num

					theMaps = #()
					
					for ext in fileFormats do
					(
						join theMaps (getFiles (mapsRoot + @"\" + ext ) recurse:true)
					)
					--add IDs if needed
					if theMaps.count > delegate.texMap_num do delegate.AddSubtex (theMaps.count-delegate.texmap_num)
					--add Textures
					for m=1 to theMaps.count do
					(
-- 						delegate.texmap[m] = vrayBitmap name:("map_id_" + m as string) hdriMapName:theMaps[m]
						delegate.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m]
					)
					--cleanup
					delegate.deleteSubtex (theMaps.count+1) (delegate.texMap_num - theMaps.count)
				)
			)
			
			on btn2 pressed do
			(
				--use a dotnet dialog to be able to multi-select
				
				theDialog = dotNetObject "System.Windows.Forms.OpenFileDialog" --create a OpenFileDialog
				theDialog.title = "PLEASE Select One Or More Files" --set the title
				theDialog.Multiselect = true --allow multiple files to be selected
				theDialog.Filter = fileTypes --specify the filter
				theDialog.FilterIndex = 1 --set the filter drop-down list to All Files
				theDialog.AutoUpgradeEnabled = true
				result = theDialog.showDialog() --display the dialog, get result into variable
				result.ToString() --when closed, convert the result to string
				result.Equals result.OK --returns TRUE if OK was pressed, FALSE otherwise
				result.Equals result.Cancel --returns TRUE if Cancel was pressed, FALSE otherwise
				theMaps = theDialog.fileNames --the selected filenames will be returned as an array

				--now for the main process
				if result.Equals result.OK do 
				(
					--first, clean up the m/s texture
					delegate.deleteSubtex 1 delegate.texMap_num

					--add IDs if needed
					if theMaps.count > delegate.texMap_num do delegate.AddSubtex (theMaps.count-delegate.texmap_num)
					--add Textures
					for m=1 to theMaps.count do
					(
-- 						delegate.texmap[m] = vrayBitmap name:("map_id_" + m as string) hdriMapName:theMaps[m]
						delegate.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m]
					)
					--cleanup
					delegate.deleteSubtex (theMaps.count+1) (delegate.texMap_num - theMaps.count)
				)
			)
		)
		on create do
		(
		)
	)
)

-- genclassID()